function varargout = decisionGUI(varargin)
% DECISIONGUI MATLAB code for decisionGUI.fig
%      DECISIONGUI, by itself, creates a new DECISIONGUI or raises the existing
%      singleton*.
%
%      H = DECISIONGUI returns the handle to a new DECISIONGUI or the handle to
%      the existing singleton*.
%
%      DECISIONGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DECISIONGUI.M with the given input arguments.
%
%      DECISIONGUI('Property','Value',...) creates a new DECISIONGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before decisionGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to decisionGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help decisionGUI

% Last Modified by GUIDE v2.5 20-Apr-2017 00:13:28

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @decisionGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @decisionGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before decisionGUI is made visible.
function decisionGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to decisionGUI (see VARARGIN)

handles.cohereVals = [0 0.1 0.2 0.5];   % options for coherence value
handles.cohere = 0;                     % selected coherence value
handles.durVals = [0.5 1 2];            % options for duration value
handles.duration = 0.5;                 % selected duration
handles.threshVals = [100 50];         % options for threshold value
handles.threshold = 100;                % selected threshold
handles.MTvals = [1 2 5];               % options for number of MT neurons
handles.MTnum = 1;                      % selected number of MT neurons
axes(handles.movieAxes)                 % remove axes from movie display
axis off

% Choose default command line output for decisionGUI
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes decisionGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = decisionGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in movieButton.
function movieButton_Callback(hObject, eventdata, handles)
% hObject    handle to movieButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if (rand(1) < 0.5)      % randomly select left or right motion
    leftRight = 1;
else
    leftRight = 0;
end
axes(handles.movieAxes)     % show dot movie
showDots (handles.cohere, leftRight, 300, handles.duration)

% --- Executes on button press in simButton.
function simButton_Callback(hObject, eventdata, handles)
% hObject    handle to simButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if (rand(1) < 0.5)      % randomly select left or right trial
    scale = 1;
else
    scale = -1;
end
switch handles.cohere   % map coherence value to stimulus condition
    case 0
        stimulus = 102;
    case 0.1
        stimulus = 102+scale;
    case 0.2
        stimulus = 102+(4*scale);
    otherwise
        stimulus = 102+(10*scale);
end
axes(handles.plotAxes)  % run simulation for selected conditions
neuralDecision(stimulus, handles.MTnum, 100*handles.duration, handles.threshold)
% Update handles structure
guidata(hObject, handles);
    
% --- Executes on selection change in cohereMenu.
function cohereMenu_Callback(hObject, eventdata, handles)
% hObject    handle to cohereMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns cohereMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from cohereMenu

handles.cohere = handles.cohereVals(get(handles.cohereMenu, 'Value'));
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function cohereMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cohereMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in durationMenu.
function durationMenu_Callback(hObject, eventdata, handles)
% hObject    handle to durationMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns durationMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from durationMenu

handles.duration = handles.durVals(get(handles.durationMenu, 'Value'));
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function durationMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to durationMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in threshMenu.
function threshMenu_Callback(hObject, eventdata, handles)
% hObject    handle to threshMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns threshMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from threshMenu

handles.threshold = handles.threshVals(get(handles.threshMenu, 'Value'));
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function threshMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to threshMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in MTneuronsMenu.
function MTneuronsMenu_Callback(hObject, eventdata, handles)
% hObject    handle to MTneuronsMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns MTneuronsMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from MTneuronsMenu

handles.MTnum = handles.MTvals(get(handles.MTneuronsMenu, 'Value'));
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function MTneuronsMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to MTneuronsMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in closeButton.
function closeButton_Callback(hObject, eventdata, handles)
% hObject    handle to closeButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

delete(handles.figure1)

% --- Executes on button press in clearButton.
function clearButton_Callback(hObject, eventdata, handles)
% hObject    handle to clearButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

axes(handles.plotAxes)  % clear plotting display area
cla
